| 導購 | 订阅 | 在线投稿
分享
 
 
 

循序漸進講解Informix SQL的十一個技巧

來源:互聯網  2008-06-04 06:44:55  評論

一、加快sql的執行速度

1.select 語句中使用sort,或join

如果你有排序和連接操作,你可以先select數據到一個臨時表中,然後再對臨時表進行處理。因爲臨時表是建立在內存中,所以比建立在磁盤上表操作要快的多。

如:

SELECT time_records.*, case_name

FROM time_records, OUTER cases

WHERE time_records.client = "AA1000"

AND time_records.case_no = cases.case_no

ORDER BY time_records.case_no

這個語句返回34個經過排序的記錄,花費了5分鍾42秒。而:

SELECT time_records.*, case_name

FROM time_records, OUTER cases

WHERE time_records.client = "AA1000"

AND time_records.case_no = cases.case_no

INTO temp foo;

SELECT * from foo ORDER BY case_no

返回34條記錄,只花費了59秒。

2.使用not in 或者not exists 語句

下面的語句看上去沒有任何問題,但是可能執行的非常慢:

SELECT code FROM table1

WHERE code NOT IN ( SELECT code FROM table2

如果使用下面的方法:

SELECT code, 0 flag

FROM table1

INTO TEMP tflag;

然後:

UPDATE tflag SET flag = 1

WHERE code IN ( SELECT code FROM table2

WHERE tflag.code = table2.code ;

然後:

SELECT * FROM

tflag

WHERE flag = 0;

看上去也許要花費更長的時間,但是你會發現不是這樣。

事實上這種方式效率更快。有可能第一種方法也會很快,那是在對相關的每個字段都建立了索引的情況下,但是那顯然不是一個好的注意。

3.避免使用過多的「or"

如果有可能的話,盡量避免過多地使用or: WHERE a = "B" OR a = "C"

要比 WHERE a IN ("B","C") 慢。 有時甚至UNION會比OR要快。

4.使用索引

在所有的join和order by 的字段上建立索引。 在where中的大多數字段建立索引。

WHERE datecol >= "this/date" AND datecol

<= "that/date" 要比 WHERE datecol BETWEEN

"this/date" AND "that/date" 慢。

二、在shell腳本中使用一個sql查詢的結果

以下的是一個運行在sh/ksh下面的腳本。在online中,如果你想要更新一個有許多表的數據庫的統計信息。這個腳本不太好。因爲這個腳本只能單個處理數據庫中的表,而不能同時處理大量的表。

例子:

# update_em

# Run UPDATE STATISTICS on a table by table basis

# DATABASE=$1

if [ -z "$DATABASE" ]

then

echo "usage: update_em dbname" >&2

exit 1

fi

isql $DATABASE - < dev/null | isql $DATABASE -

output to pipe "cat" without headings

select "update statistics for table ", tabname, ";"

from systables where tabid >= 100 order by tabname;

EOF

exit 0

也許你已經注意到exit的返回值對不同的isql不是都相同,因此這樣作不是很可靠,代替通過$?來檢查返回值的更好的主意是將標准錯誤重定向到一個文件中,然後在這個文件中grep 「error"。例如:

# Generate the data

isql -qr <<!>stage.rep 2>$stage.err

database $database;

select ...

!

# Check for errors

if grep -i "error" $stage.err >/dev/null

then

...error_handler...

fi

三、對一個計算産生的字段創建視圖

應該這樣寫:

CREATE VIEW tst (cout) AS

SELECT ship_charge - totval

FROM orders WHERE ship_charge > 0;

四、只select 出數據庫中的部分數據(例如10%)

問題:如果你想要得到一個select 語句正常返回的數據的一部分,例如:

SELECT firstname, lastname, city, state

FROM bigdatabase

WHERE state = "TX"

回答: 有一個方法可以返回一個近似值,只需要在where後加上:AND rowid=(trunc(rowid/x)*x)

其中的x代表你想要返回的總的記錄的1/x。需要說明的是,這種方法只能返回一個近似的值,並且表中的數據在物理上分布的連續性。

五、創建一個表結構和永久表完全一致的臨時表。

例如:CREATE TEMP TABLE mytemp (prodno LIKE

product.prodno desc LIKE product.desc)

你可以使用如下的語句:

SELECT prodno, desc FROM product

WHERE ROWID = -1

INSERT INTO TEMP mytemp

六、更改serial類型下一次插入操作産生的值

我們知道serial類型的字段是系統自動增加的整數字段,那麽怎樣能控制下一個serial類型字段的值。想要下一個插入的serial類型的值比默認值大,可以用:

ALTER TABLE tabname MODIFY

( ser_col_name SERIAL([new_start_number])

想要下一個插入的serial類型的值比默認的值要小,首先需要將serial類型重新置爲1:

INSERT INTO table (serial_column) VALUES (2147483647);

INSERT INTO table (serial_column) VALUES (0); -- 重新從1開始!

....然後執行ALTER TABLE(就像上面的做法一樣)。

七、在發生錯誤的時候終止sql腳本的執行

如果你創建了一個sql腳本,並且在UNIX命令行中使用以下的方式來執行這個腳本:

$ dbaccess <腳本文件名>

這時,腳本中的所有的sql語句都會被執行,即使其中的一個sql語句發生了錯誤。例如,如果你腳本中爲如下的語句:

BEGIN WORK;

INSERT INTO history

SELECT *

FROM current

WHERE month = 11;

DELETE FROM current

WHERE month = 11;

COMMIT WORK;

如果INSERT語句失敗了,DELETE語句仍舊會繼續執行。直到commit work。這樣的後果可能會很嚴重。你可以通過設置一個環境變量來防止這種情況的發生。 DBACCNOIGN=1

八、設置decimal字段運算結果的精度

假定你使用dbaccess或者isql,設置環境變量DBFLTMASK=6 就可以設置爲小數點後面6位,比如:

CREATE TEMP TABLE t

( col_a DECIMAL(8,4) NOT NULL,

col_b DECIMAL(8,4) NOT NULL,

col_c DECIMAL(8,4) NOT NULL

);

INSERT INTO t VALUES(1.2345, 3.4567, 5.6789);

SELECT (col_a + col_b) / col_c AS value FROM t;

value 0.826075

如果DBFLTMASK=7

value 0.8260755

九、遇到sysprocplan表被鎖的提示

sysprocplan表是sysmaster庫中的一個表,其中記錄存儲過程經過優化的查詢計劃。每當查詢樹中的數據庫對象有任何結構上的變化,這個查詢計劃就會自動更新。如果對查詢樹中存在的任何表有update statistics操作,也會自動更新查詢計劃。在查詢計劃更新的時候,會對sysporcplan表中的相關記錄加鎖。

注意:每次你對一個表更新統計的時候,也同時會更新于這個表相關的存儲過程,即UPDATE STATISTICS FOR PROCEDURE 。

你可以作的另外一件事情就是:在存儲過程中使用SET OPTIMIZATION LOW,這會讓優化器在存儲過程運行的時候不會試圖去重新優化它。否則存儲過程通常都會被重新優化一次。

十、刪除掉表中重複的記錄

假設「keycol」字段的值唯一,而且沒有對表進行分片,並且沒有其它的人正在刪除"sometable"中的記錄,你可以執行如下的SQL:

delete from sometable as a where rowid <>

(select min(rowid) from sometable where keycol = a.keycol)

如果這個表使用表分片,rowid不存在,你還可以用如下的方法:

BEGIN WORK;

SELECT DISTINCT * FROM Table INTO TEMP Temp1;

DELETE FROM Table WHERE 1 = 1;

INSERT INTO Table SELECT * FROM Temp1;

COMMIT WORK;

對于規模較小或中等的表,並且你有足夠的存儲空間來存儲整個的臨時表的時候,這種方法通常十分有效。

十一、加快SELECT COUNT(DISTINCT)的速度

通常「SELECT COUNT(DISTINCT)」這樣的操作要花費比較長的時間,如果按照下面的示例去作:

SELECT UNIQUE xxx INTO TEMP XXX " 然後再"SELECT COUNT(*) FROM TEMP XXX"

此例一般可以提高幾倍的效率。

一、加快sql的執行速度 1.select 語句中使用sort,或join 如果你有排序和連接操作,你可以先select數據到一個臨時表中,然後再對臨時表進行處理。因爲臨時表是建立在內存中,所以比建立在磁盤上表操作要快的多。 如: SELECT time_records.*, case_name FROM time_records, OUTER cases WHERE time_records.client = "AA1000" AND time_records.case_no = cases.case_no ORDER BY time_records.case_no 這個語句返回34個經過排序的記錄,花費了5分鍾42秒。而: SELECT time_records.*, case_name FROM time_records, OUTER cases WHERE time_records.client = "AA1000" AND time_records.case_no = cases.case_no INTO temp foo; SELECT * from foo ORDER BY case_no 返回34條記錄,只花費了59秒。 2.使用not in 或者not exists 語句 下面的語句看上去沒有任何問題,但是可能執行的非常慢: SELECT code FROM table1 WHERE code NOT IN ( SELECT code FROM table2 如果使用下面的方法: SELECT code, 0 flag FROM table1 INTO TEMP tflag; 然後: UPDATE tflag SET flag = 1 WHERE code IN ( SELECT code FROM table2 WHERE tflag.code = table2.code ; 然後: SELECT * FROM tflag WHERE flag = 0; 看上去也許要花費更長的時間,但是你會發現不是這樣。 事實上這種方式效率更快。有可能第一種方法也會很快,那是在對相關的每個字段都建立了索引的情況下,但是那顯然不是一個好的注意。 3.避免使用過多的「or" 如果有可能的話,盡量避免過多地使用or: WHERE a = "B" OR a = "C" 要比 WHERE a IN ("B","C") 慢。 有時甚至UNION會比OR要快。 4.使用索引 在所有的join和order by 的字段上建立索引。 在where中的大多數字段建立索引。 WHERE datecol >= "this/date" AND datecol <= "that/date" 要比 WHERE datecol BETWEEN "this/date" AND "that/date" 慢。 二、在shell腳本中使用一個sql查詢的結果 以下的是一個運行在sh/ksh下面的腳本。在online中,如果你想要更新一個有許多表的數據庫的統計信息。這個腳本不太好。因爲這個腳本只能單個處理數據庫中的表,而不能同時處理大量的表。 例子: # update_em # Run UPDATE STATISTICS on a table by table basis # DATABASE=$1 if [ -z "$DATABASE" ] then echo "usage: update_em dbname" >&2 exit 1 fi isql $DATABASE - < dev/null | isql $DATABASE - output to pipe "cat" without headings select "update statistics for table ", tabname, ";" from systables where tabid >= 100 order by tabname; EOF exit 0 也許你已經注意到exit的返回值對不同的isql不是都相同,因此這樣作不是很可靠,代替通過$?來檢查返回值的更好的主意是將標准錯誤重定向到一個文件中,然後在這個文件中grep 「error"。例如: # Generate the data isql -qr <<!>stage.rep 2>$stage.err database $database; select ... ! # Check for errors if grep -i "error" $stage.err >/dev/null then ...error_handler... fi 三、對一個計算産生的字段創建視圖 應該這樣寫: CREATE VIEW tst (cout) AS SELECT ship_charge - totval FROM orders WHERE ship_charge > 0; 四、只select 出數據庫中的部分數據(例如10%) 問題:如果你想要得到一個select 語句正常返回的數據的一部分,例如: SELECT firstname, lastname, city, state FROM bigdatabase WHERE state = "TX" 回答: 有一個方法可以返回一個近似值,只需要在where後加上:AND rowid=(trunc(rowid/x)*x) 其中的x代表你想要返回的總的記錄的1/x。需要說明的是,這種方法只能返回一個近似的值,並且表中的數據在物理上分布的連續性。 五、創建一個表結構和永久表完全一致的臨時表。 例如:CREATE TEMP TABLE mytemp (prodno LIKE product.prodno desc LIKE product.desc) 你可以使用如下的語句: SELECT prodno, desc FROM product WHERE ROWID = -1 INSERT INTO TEMP mytemp 六、更改serial類型下一次插入操作産生的值 我們知道serial類型的字段是系統自動增加的整數字段,那麽怎樣能控制下一個serial類型字段的值。想要下一個插入的serial類型的值比默認值大,可以用: ALTER TABLE tabname MODIFY ( ser_col_name SERIAL([new_start_number]) 想要下一個插入的serial類型的值比默認的值要小,首先需要將serial類型重新置爲1: INSERT INTO table (serial_column) VALUES (2147483647); INSERT INTO table (serial_column) VALUES (0); -- 重新從1開始! ....然後執行ALTER TABLE(就像上面的做法一樣)。 七、在發生錯誤的時候終止sql腳本的執行 如果你創建了一個sql腳本,並且在UNIX命令行中使用以下的方式來執行這個腳本: $ dbaccess <腳本文件名> 這時,腳本中的所有的sql語句都會被執行,即使其中的一個sql語句發生了錯誤。例如,如果你腳本中爲如下的語句: BEGIN WORK; INSERT INTO history SELECT * FROM current WHERE month = 11; DELETE FROM current WHERE month = 11; COMMIT WORK; 如果INSERT語句失敗了,DELETE語句仍舊會繼續執行。直到commit work。這樣的後果可能會很嚴重。你可以通過設置一個環境變量來防止這種情況的發生。 DBACCNOIGN=1 八、設置decimal字段運算結果的精度 假定你使用dbaccess或者isql,設置環境變量DBFLTMASK=6 就可以設置爲小數點後面6位,比如: CREATE TEMP TABLE t ( col_a DECIMAL(8,4) NOT NULL, col_b DECIMAL(8,4) NOT NULL, col_c DECIMAL(8,4) NOT NULL ); INSERT INTO t VALUES(1.2345, 3.4567, 5.6789); SELECT (col_a + col_b) / col_c AS value FROM t; value 0.826075 如果DBFLTMASK=7 value 0.8260755 九、遇到sysprocplan表被鎖的提示 sysprocplan表是sysmaster庫中的一個表,其中記錄存儲過程經過優化的查詢計劃。每當查詢樹中的數據庫對象有任何結構上的變化,這個查詢計劃就會自動更新。如果對查詢樹中存在的任何表有update statistics操作,也會自動更新查詢計劃。在查詢計劃更新的時候,會對sysporcplan表中的相關記錄加鎖。 注意:每次你對一個表更新統計的時候,也同時會更新于這個表相關的存儲過程,即UPDATE STATISTICS FOR PROCEDURE 。 你可以作的另外一件事情就是:在存儲過程中使用SET OPTIMIZATION LOW,這會讓優化器在存儲過程運行的時候不會試圖去重新優化它。否則存儲過程通常都會被重新優化一次。 十、刪除掉表中重複的記錄 假設「keycol」字段的值唯一,而且沒有對表進行分片,並且沒有其它的人正在刪除"sometable"中的記錄,你可以執行如下的SQL: delete from sometable as a where rowid <> (select min(rowid) from sometable where keycol = a.keycol) 如果這個表使用表分片,rowid不存在,你還可以用如下的方法: BEGIN WORK; SELECT DISTINCT * FROM Table INTO TEMP Temp1; DELETE FROM Table WHERE 1 = 1; INSERT INTO Table SELECT * FROM Temp1; COMMIT WORK; 對于規模較小或中等的表,並且你有足夠的存儲空間來存儲整個的臨時表的時候,這種方法通常十分有效。 十一、加快SELECT COUNT(DISTINCT)的速度 通常「SELECT COUNT(DISTINCT)」這樣的操作要花費比較長的時間,如果按照下面的示例去作: SELECT UNIQUE xxx INTO TEMP XXX " 然後再"SELECT COUNT(*) FROM TEMP XXX" 此例一般可以提高幾倍的效率。
󰈣󰈤
王朝萬家燈火計劃
期待原創作者加盟
 
 
 
>>返回首頁<<
 
 
 
 
 熱帖排行
 
 
 
靜靜地坐在廢墟上,四周的荒凉一望無際,忽然覺得,淒涼也很美
© 2005- 王朝網路 版權所有